include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "relations.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
axiom le : nat -> nat -> Prop.
axiom le_n : \forall (n:nat). (le)  n n.
axiom le_S : \forall (n:nat). \forall (m:nat). ((le)  n m) -> (le)  n ((S)  m).
axiom le_ind : \forall (n:nat). \forall (Q:nat -> Prop). (Q n) -> (\forall (m:nat). ((le)  n m) -> (Q m) -> Q ((S)  m)) -> \forall (m:nat). ((le)  n m) -> Q m.
axiom plus : nat -> nat -> nat.
axiom plus_body : nat -> nat -> nat.
axiom axiom_plus : \forall (n:nat). (equal) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n).
definition eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((axiom_plus) (n)).
definition sym_eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (plus_body)  n) ((plus)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((eq_plus) (n)).
axiom axiom_plus_body_O : (equal) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m).
definition eq_plus_body_O : (leibniz) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m) := ((((equal_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (axiom_plus_body_O).
definition sym_eq_plus_body_O : (leibniz) (nat -> nat) (\lambda m : nat. m) ((plus_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (eq_plus_body_O).
axiom axiom_plus_body_S : \forall (n:nat). (equal) (nat -> nat) ((plus_body)  ((S)  n)) (\lambda m : nat. (S)  ((plus)  n m)).
definition eq_plus_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((plus_body)  ((S)  n)) (\lambda m : nat. (S)  ((plus)  n m)) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus_body)  ((S)  n))) (\lambda m : nat. (S)  ((plus)  n m))) ((axiom_plus_body_S) (n)).
definition sym_eq_plus_body_S : \forall (n:nat). (leibniz) (nat -> nat) (\lambda m : nat. (S)  ((plus)  n m)) ((plus_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus_body)  ((S)  n))) (\lambda m : nat. (S)  ((plus)  n m))) ((eq_plus_body_S) (n)).
definition le_S_S : \forall (n:nat). \forall (m:nat). ((le)  n m) -> (le)  ((S)  n) ((S)  m) := \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (((((((le_ind) (n)) (\lambda x_417 : nat. (le)  ((S)  n) ((S)  x_417))) ((le_n) ((S)  n))) (\lambda m0 : nat. \lambda j_x_419 : (le)  n m0. (\lambda j_x_421 : (le)  ((S)  n) ((S)  m0). ((((le_S) ((S)  n)) ((S)  m0)) (j_x_421))))) (m)) (lenm)).
definition monotonic_le_plus_r : \forall (n:nat). (monotonic) (nat) (le)  (\lambda m : nat. (plus)  n m) := \lambda n : nat. \lambda a : nat. \lambda b : nat. ((((nat_ind) (\lambda j_x_365 : nat. ((le)  a b) -> (le)  ((plus)  j_x_365 a) ((plus)  j_x_365 b))) ((((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. ((le)  a b) -> (le)  ((plus)  (O)  a) (y b))) ((((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. ((le)  a b) -> (le)  (y a) ((filter_nat_type) (nat -> nat) (plus_body)  (O)  b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. ((le)  a b) -> (le)  (y a) ((filter_nat_type) (nat -> nat) (plus_body)  (O)  b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. ((le)  a b) -> (le)  ((plus_body)  (O)  a) (y b))) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. ((le)  a b) -> (le)  ((plus_body)  (O)  a) (y b))) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. ((le)  a b) -> (le)  (y a) b)) (\lambda auto : (le)  a b. (auto))))))))) (\lambda m : nat. \lambda H : ((le)  a b) -> (le)  ((plus)  m a) ((plus)  m b). (\lambda leab : (le)  a b. ((((sym_eq_plus) ((S)  m)) (\lambda y : nat -> nat. (le)  ((plus)  ((S)  m) a) (y b))) ((((sym_eq_plus) ((S)  m)) (\lambda y : nat -> nat. (le)  (y a) ((filter_nat_type) (nat -> nat) (plus_body)  ((S)  m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((plus_body) )) (m)) (\lambda y : nat -> nat. (le)  (y a) ((filter_nat_type) (nat -> nat) (plus_body)  ((S)  m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((plus_body) )) (m)) (\lambda y : nat -> nat. (le)  ((plus_body)  ((S)  m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (\lambda y : nat -> nat. (le)  ((plus_body)  ((S)  m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (\lambda y : nat -> nat. (le)  (y a) ((S)  ((plus)  m b)))) ((((le_S_S) ((plus)  m a)) ((plus)  m b)) ((H) (leab)))))))))))) (n).
